#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <Servo.h>
#include <DS3231.h>

LiquidCrystal_I2C lcd(0x27, 16, 2);
DS3231 rtc(SDA, SCL);
#define Button 2

Servo my_servo;
long int start;
char *currentTime;
int command;
int feed;

void setup()
{
  pinMode(Button, INPUT);
  my_servo.attach(9);
  my_servo.write(110);
  pinMode(9, OUTPUT);
  lcd.begin();
  lcd.backlight();
  
  rtc.begin();
  Serial.begin(9600);
  feed = 0;
  
}

void loop()
{
  if (Serial.available() > 0) {
    command = Serial.read();
    if (command == 'F') {
      feed = 1;
      Serial.println("Meal time!");
    } else {
      feed = 0;
    }
  }
  int btnValue = digitalRead(Button);
  currentTime = rtc.getTimeStr(FORMAT_LONG);
  if (btnValue == HIGH || 
      !strcmp(currentTime, "12:00:00") || 
      !strcmp(currentTime, "18:00:00") ||
      feed == 1) {
    currentTime = rtc.getTimeStr(FORMAT_SHORT);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Last meal:");
    lcd.setCursor(11, 0);
    lcd.print(currentTime);
    lcd.setCursor(3, 1);
    lcd.print(rtc.getDateStr(FORMAT_LONG, FORMAT_LITTLEENDIAN));
    for (int pos = 110; pos >= -30; pos -= 1) {
      my_servo.write(pos);
      delay(5);
    }
    for (int pos = -30; pos <= 110; pos += 1) {
      my_servo.write(pos);
      delay(5);
    }
    feed = 0;
  }
  
}
